unit OTFEFreeOTFE_frmCypherInfo;
// Description: 
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  OTFEFreeOTFE_U;

type
  TfrmCypherInfo = class(TForm)
    gbCypherDriver: TGroupBox;
    gbCypher: TGroupBox;
    edDriverDeviceName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    edDriverDeviceUserModeName: TEdit;
    edDriverDeviceKernelModeName: TEdit;
    edDriverTitle: TEdit;
    edDriverVersionID: TEdit;
    edDriverCypherCount: TEdit;
    edCypherGUID: TEdit;
    edCypherTitle: TEdit;
    edCypherMode: TEdit;
    edCypherBlockSize: TEdit;
    edCypherVersionID: TEdit;
    pbClose: TButton;
    Label12: TLabel;
    edDriverGUID: TEdit;
    edCypherKeySize: TEdit;
    Label13: TLabel;
    procedure pbCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    OTFEFreeOTFEObj: TOTFEFreeOTFE;

    // These two items uniquely identify which should be shown
    ShowDriverName: string;
    ShowGUID: TGUID;
  end;


implementation

{$R *.DFM}

uses
  ComObj,  // Required for GUIDToString(...)
  ActiveX,  // Required for IsEqualGUID
  OTFEFreeOTFE_DriverCypherAPI;


procedure TfrmCypherInfo.pbCloseClick(Sender: TObject);
begin
  Close();

end;


procedure TfrmCypherInfo.FormShow(Sender: TObject);
var
  cypherDrivers: array of TFreeOTFECypherDriver;
  i, j: integer;
  currCypherDriver: TFreeOTFECypherDriver;
  currCypher: TFreeOTFECypher;
  tmpString: string;
begin
  // Blank out in case none found
  edDriverGUID.Text                 := '<Unable to locate correct cypher driver>';
  edDriverDeviceName.Text           := '<Unable to locate correct cypher driver>';
  edDriverDeviceKernelModeName.Text := '<Unable to locate correct cypher driver>';
  edDriverDeviceUserModeName.Text   := '<Unable to locate correct cypher driver>';
  edDriverTitle.Text                := '<Unable to locate correct cypher driver>';
  edDriverVersionID.Text            := '<Unable to locate correct cypher driver>';
  edDriverCypherCount.Text          := '<Unable to locate correct cypher driver>';

  edCypherGUID.Text      := '<Unable to locate cypher>';
  edCypherTitle.Text     := '<Unable to locate cypher>';
  edCypherMode.Text      := '<Unable to locate cypher>';
  edCypherVersionID.Text := '<Unable to locate cypher>';
  edCypherKeySize.Text   := '<Unable to locate cypher>';
  edCypherBlockSize.Text := '<Unable to locate cypher>';


  SetLength(cypherDrivers, 0);
  if OTFEFreeOTFEObj.GetCypherDrivers(TFreeOTFECypherDriverArray(cypherDrivers)) then
    begin
    for i:=low(cypherDrivers) to high(cypherDrivers) do
      begin
      currCypherDriver := cypherDrivers[i];

      if (
          (currCypherDriver.DeviceKernelModeName = ShowDriverName) OR
          (currCypherDriver.DeviceUserModeName = ShowDriverName)
          ) then
        begin
        edDriverGUID.Text                 := GUIDToString(currCypherDriver.DriverGUID);
        edDriverDeviceName.Text           := currCypherDriver.DeviceName;
        edDriverDeviceKernelModeName.Text := currCypherDriver.DeviceKernelModeName;
        edDriverDeviceUserModeName.Text   := currCypherDriver.DeviceUserModeName;
        edDriverTitle.Text                := currCypherDriver.Title;
        edDriverVersionID.Text            := OTFEFreeOTFEObj.VersionIDToStr(currCypherDriver.VersionID);
        edDriverCypherCount.Text          := inttostr(currCypherDriver.CypherCount);


        for j:=low(cypherDrivers[i].Cyphers) to high(cypherDrivers[i].Cyphers) do
          begin
          currCypher := cypherDrivers[i].Cyphers[j];

          if (IsEqualGUID(currCypher.CypherGUID, ShowGUID)) then
            begin
            edCypherGUID.Text      := GUIDToString(currCypher.CypherGUID);
            edCypherTitle.Text     := currCypher.Title;
            edCypherMode.Text      := FreeOTFECypherModeTitle[currCypher.Mode];

            tmpString := inttostr(currCypher.KeySize) + ' bits';
            if (currCypher.KeySize = 0) then
              begin
              tmpString := tmpString + ' (null key only)';
              end
            else if (currCypher.KeySize = -1) then
              begin
              tmpString := tmpString + ' (arbitary keysize allowed)';
              end;
            edCypherKeySize.Text   := tmpString;

            tmpString := inttostr(currCypher.BlockSize) + ' bits';
            if (currCypher.BlockSize = -1) then
              begin
              tmpString := tmpString + ' (arbitary blocksize allowed)';
              end;
            edCypherBlockSize.Text := tmpString;

            edCypherVersionID.Text := OTFEFreeOTFEObj.VersionIDToStr(currCypher.VersionID);
            end;

          end;

        end;

      end;

    end;

end;


END.

