unit OTFEFreeOTFE_frmHashInfo;
// Description: 
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  OTFEFreeOTFE_U;

type
  TfrmHashInfo = class(TForm)
    gbHashDriver: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edDriverDeviceName: TEdit;
    edDriverDeviceUserModeName: TEdit;
    edDriverDeviceKernelModeName: TEdit;
    edDriverTitle: TEdit;
    edDriverVersionID: TEdit;
    edDriverHashCount: TEdit;
    gbHash: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    edHashGUID: TEdit;
    edHashTitle: TEdit;
    edHashLength: TEdit;
    edHashVersionID: TEdit;
    pbClose: TButton;
    edDriverGUID: TEdit;
    Label9: TLabel;
    edHashBlockSize: TEdit;
    Label12: TLabel;
    procedure pbCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    OTFEFreeOTFEObj: TOTFEFreeOTFE;

    // These two items uniquely identify which should be shown
    ShowDriverName: string;
    ShowGUID: TGUID;
  end;


implementation

{$R *.DFM}

uses
  ComObj,  // Required for GUIDToString(...)
  ActiveX;  // Required for IsEqualGUID


procedure TfrmHashInfo.pbCloseClick(Sender: TObject);
begin
  Close();
  
end;

procedure TfrmHashInfo.FormShow(Sender: TObject);
var
  hashDrivers: array of TFreeOTFEHashDriver;
  i, j: integer;
  currHashDriver: TFreeOTFEHashDriver;
  currHash: TFreeOTFEHash;
  tmpString: string;
begin
  // Blank out in case none found
  edDriverGUID.Text                 := '<Unable to locate correct hash driver>';
  edDriverDeviceName.Text           := '<Unable to locate correct hash driver>';
  edDriverDeviceKernelModeName.Text := '<Unable to locate correct hash driver>';
  edDriverDeviceUserModeName.Text   := '<Unable to locate correct hash driver>';
  edDriverTitle.Text                := '<Unable to locate correct hash driver>';
  edDriverVersionID.Text            := '<Unable to locate correct hash driver>';
  edDriverHashCount.Text            := '<Unable to locate correct hash driver>';

  edHashGUID.Text       := '<Unable to locate hash>';
  edHashTitle.Text      := '<Unable to locate hash>';
  edHashVersionID.Text  := '<Unable to locate hash>';
  edHashLength.Text     := '<Unable to locate hash>';
  edHashBlockSize.Text  := '<Unable to locate hash>';


  SetLength(hashDrivers, 0);
  if OTFEFreeOTFEObj.GetHashDrivers(TFreeOTFEHashDriverArray(hashDrivers)) then
    begin
    for i:=low(hashDrivers) to high(hashDrivers) do
      begin
      currHashDriver := hashDrivers[i];
      
      if (
          (currHashDriver.DeviceKernelModeName = ShowDriverName) OR
          (currHashDriver.DeviceUserModeName = ShowDriverName)
         ) then
        begin
        edDriverGUID.Text                 := GUIDToString(currHashDriver.DriverGUID);
        edDriverDeviceName.Text           := currHashDriver.DeviceName;
        edDriverDeviceKernelModeName.Text := currHashDriver.DeviceKernelModeName;
        edDriverDeviceUserModeName.Text   := currHashDriver.DeviceUserModeName;
        edDriverTitle.Text                := currHashDriver.Title;
        edDriverVersionID.Text            := OTFEFreeOTFEObj.VersionIDToStr(currHashDriver.VersionID);
        edDriverHashCount.Text            := inttostr(currHashDriver.HashCount);

        for j:=low(hashDrivers[i].Hashes) to high(hashDrivers[i].Hashes) do
          begin
          currHash := hashDrivers[i].Hashes[j];

          if (IsEqualGUID(currHash.HashGUID, ShowGUID)) then
            begin
            edHashGUID.Text       := GUIDToString(currHash.HashGUID);
            edHashTitle.Text      := currHash.Title;
            edHashVersionID.Text  := OTFEFreeOTFEObj.VersionIDToStr(currHash.VersionID);

            tmpString := inttostr(currHash.Length) + ' bits';
            if (currHash.Length = -1) then
              begin
              tmpString := tmpString + ' (length of hash returned may vary)';
              end;
            edHashLength.Text := tmpString;

            tmpString := inttostr(currHash.BlockSize) + ' bits';
            if (currHash.BlockSize = -1) then
              begin
              tmpString := tmpString + ' (n/a)';
              end;
            edHashBlockSize.Text := tmpString;
            end;

          end;

        end;

      end;

    end;

end;


END.

